package org.zipcoder.store;

import java.util.*;

public class MyHashMap implements MyMap{
    // final field that doesn't change for any object
    private static final int BUCKET_SIZE = 15;

    // instance field that can only be set once. It is different for every Object
    private final List<Entry>[] entries;

    public MyHashMap(){
        entries = new List[BUCKET_SIZE];

        for(int i = 0; i < BUCKET_SIZE; i++) {
            entries[i] = new ArrayList<>();
        }
    }

    @Override
    public int size() {
        int size = 0;
        for (List<Entry> e: entries){
            size += e.size();
        }
        return size;
    }

    @Override
    public boolean isEmptry() {
        if (this.size() == 0){
            return true;
        }
        return false;
    }

    @Override
    public Cart get(User key) {
        Cart value = null;
        for(Entry element: entries[bucketIndex(key)]){
                if (element.getKey().equals(key)){
                    value = element.getValue();
                }
        }
        return value;
    }

    @Override
    public void put(User key, Cart value) {
        entries[bucketIndex(key)].add(new Entry(key, value));
    }

    @Override
    public List<User> getKeys() {
        List<User> result = new ArrayList<>();
        for(List<Entry> e: entries){
            for(Entry el: e){
                result.add(el.getKey());
            }
        }
        return result;
    }

    @Override
    public List<Cart> getValues() {
        List<Cart> result = new ArrayList<>();
        for(List<Entry> e: entries){
            for(Entry el: e){
                result.add(el.getValue());
            }
        }
        return result;
    }

    @Override
    public Cart remove(User key) {

        Cart value = null;
        Entry entry = null;
        for(Entry element: entries[bucketIndex(key)]){
            if (element.getKey().equals(key)){
                value = element.getValue();
                entry = element;
            }
        }
        entries[bucketIndex(key)].remove(entry);

        return value;
    }

    private int bucketIndex(User key){
        return Math.abs(key.hashCode()) % entries.length;
    }
}
